#include "Windows.h"
#include "OdysseyDLL.h"
#include "stdio.h"
/* This function calls for a pointer to the start of the surface
to the end of it ...

  map is 384x384, which is 147456 pixels
  then, multiply by two since it uses 16bit color.
  294,912 ....
*/

//This is the actual function for shading the map


//__int32 _stdcall ShadeMap565(__int32 sfcptr, __int32 color)
//{
//	unsigned __int32 x,y;
//	unsigned __int16 R, G, B, *curptr = (unsigned __int16 *)sfcptr;
//	unsigned __int8 *ptrLightMap = (unsigned __int8*)LightMap;
//	R = (color & 63488);
//	G = (color & 2016);
//	B = (color & 31);
//	for(x=0;x<147456;x++) {
//		*curptr = (63488 & ((*curptr & 63488) + (((R - (*curptr & 63488)) * *ptrLightMap) >>8))) | (2016 & ((*curptr & 2016) + (((G - (*curptr & 2016)) * *ptrLightMap) >>8))) |	(31 & ((*curptr & 31) + (((B - (*curptr & 31)) * *ptrLightMap) >>8)));
//		curptr++;
//		ptrLightMap++;
//	}
//	return 0;
//}

__int32 _stdcall ShadeMap2565(__int32 sPtr, __int32 alpha_val, __int8 rVal, __int8 gVal, __int8 bVal)
{
		__int64 RedBlueMask=0x001F001F001F001F;
		//__int64 GreenMask=0x07E007E007E007E0;
		__int64 GreenMask=0x003F003F003F003F;
		__int16 alpha=256-alpha_val;			// The inverse of the alpha_val - for use with the source surface

		//__int64 Alphad=__int64(alpha_val)+(__int64(alpha_val)<<16)+(__int64(alpha_val)<<32)+(__int64(alpha_val)<<48);		// Create a 64-bit integer from the alpha value for 4 pixels (16bits*4pixels=64bits)
        __int64 Alphas = ((__int64)alpha) + ((__int64)alpha<<16) + ((__int64)alpha<<32) + ((__int64)alpha<<48);						// Again but with the inverse alpha value

		unsigned __int32 ptrLightMap;
		ptrLightMap = (unsigned __int32)&LightMap;

		__asm
		{
                mov     esi,sPtr			// So we don't have to refer to memory, copy the pointer to the src surface to a register
                mov     edi,ptrLightMap		// Move the pointer to the Light Map here ..
				movq    mm7,Alphas		    // Copy the source alphavalues to the mm7 register
				movq	mm3,RedBlueMask		//load the red colorblend value into the mm3 register
				movq	mm4,GreenMask		//load the green colorblend value into the mm4 register

                mov     edx,384				// Copy the height of the region to be blitted to the dx register
NextLine:
                mov     cx,96				// Every time we start a new line, reset the cx register to how many times we need to treat 4 pixels in a line
NextPixels:
				movq	mm7, [edi]			// Get Light Source Values
                movq    mm0, [esi]			// Get 4 source pixel values

                movq    mm2,mm0				// Make a copy of the source pixel value
                psrlw   mm2,11				// Shift the src pixels right to align them to the alpha values
                pand    mm2,mm3				// Isolate the red values in the source pixels
				pmullw  mm2,mm7				// Multiply the src pixels by the alpha value
                psrlw   mm2,8				// Divide by 256 essentially - we have multiplied in total by 255 in the src and dest pixels, so now we've gotta reverse that process
                psllw   mm2,11				// Move the values back to their original bit positions
                movq    mm6,mm2				// Copy the blended red colors to mm6 where the new pixels will be built

                movq    mm2,mm0				// Reset the src pixel value so we get all the colors back
                psrlw   mm2,5				// Shift the src pixels right to align them with the alpha values
                pand    mm2,mm4				// Isolate the green values in the src pixels
                pmullw  mm2,mm7				// Multiply the src pixels by the alpha value
                psrlw   mm2,8				// Divide by 256 - why? explained for the red values
                psllw   mm2,5				// Return the green values to their original bit positions
                por     mm6,mm2				// Copy the blended green colors to mm6 - we're 2/3 of the way there!

                movq    mm2,mm0				// Reset the src pixel value again
				pand    mm2,mm3				// Isolate the blue values in the src pixels
                pmullw  mm2,mm7				// Blue pixels are already aligned with alpha values so we skip to multiplying them by the alpha value
                psrlw   mm2,8				// Divide by 256 - why? explained for the red values
                por     mm6,mm2				// Copy the blended blue colors to mm6 - the pixels have now been completely blended!

                movq    [esi],mm6			// Copy the new pixels to the destination
SkipPixels:
                add     esi,8				// Set the src pointer to point at the next set of 4 pixels
				add		edi,8

                dec     ecx					// Decrement the width counter
                jnz     NextPixels			// If we've still got more pixels to treat, jump back to the beginning to treat more, otherwise continue on......

                dec     edx					// Decrement the height counter
                jnz     NextLine			// If we've still got lines to treat, jump back to the beginning and get going!  otherwise.......
                emms						// Clean up our mmx registers		
		}
		return 1;
}

/*__int32 _stdcall CreateLightMap(struct LightSource *LS, unsigned __int8 ambientalpha)
{
	static __int8 toggle;
	__int32 x, y, sx, sy, ex, ey;
	__int32 c;
	__int32 d, a;
	unsigned __int32 r;
	unsigned __int16 *ptrLS = (unsigned __int16 *)LightMap;

	toggle = 1 - toggle;
	if (toggle) {
		ambientalpha = 255 - ambientalpha;
		for(x=0;x<147456;x++){
			*ptrLS = ambientalpha;
			ptrLS++;
		}
		for(c=0;c<30;c++){
			if(LS->Intensity && LS->Radius) {
				r = LS->Radius * LS->Radius;
				sx = LS->x - LS->Radius;
				sy = LS->y - LS->Radius;
				ex = LS->x + LS->Radius;
				ey = LS->y + LS->Radius;
				if (sx < 0) {sx=0;}
				if (sy < 0) {sy=0;}
				if (ex > 383) {ex=383;}
				if (ey > 383) {ey=383;}
				for(y=sy;y<=ey;y++) {
					for(x=sx;x<=ex;x++) {
						d = (x-LS->x)*(x-LS->x) + (y-LS->y)*(y-LS->y);
						if (d <= r) {
							a = (d * (LS->Intensity)/r);
							a = (LS->Intensity) - a;
							LightMap[y][x] += a;
							if (LightMap[y][x] > 255) {LightMap[y][x]=255;}
						}
					}
				}
			}
			LS++;
		}
	}
	return 0;
}*/

__int32 _stdcall CreateLightMap(struct LightSource *LS, unsigned __int8 ambientalpha)
{
	__int16 x, y, c, sx, sy, ex, ey;
	__int32 d, a;
	unsigned __int32 r;
	unsigned __int16 *ptrLS = (unsigned __int16 *)LightMap;

	ambientalpha = 255 - ambientalpha;
	for(x=0;x<147456;x++){
		*ptrLS = ambientalpha;
		ptrLS++;
	}
	for(c=0;c<30;c++){
		if((__int32)LS->Intensity && (__int32)LS->Radius) {
			r = LS->Radius * LS->Radius;
			if ((__int32)LS->x - (__int32)LS->Radius < 0) {sx=0;} else { sx = (__int32)LS->x - (__int32)LS->Radius; }
			if ((__int32)LS->y - (__int32)LS->Radius < 0) {sy=0;} else { sy = (__int32)LS->y - (__int32)LS->Radius; }
			if ((__int32)LS->x + (__int32)LS->Radius > 383) {ex=383;} else { ex = (__int32)LS->x + (__int32)LS->Radius; }
			if ((__int32)LS->y - (__int32)LS->Radius < 383) {ey=383;} else { ey = (__int32)LS->y + (__int32)LS->Radius; }
			for(y=sy;y<=ey;y++) {
				for(x=sx;x<=ex;x++) {
					d = (x-LS->x)*(x-LS->x) + (y-LS->y)*(y-LS->y);
					if (d <= r) {
						a = (d * ((__int32)LS->Intensity)/r);
						a = ((__int32)LS->Intensity) - a;
						a + LightMap[y][x] > 255 ? LightMap[y][x] = 255 : LightMap[y][x] += a;
					}
				}
			}
		}
		LS++;
	}
	return 0;
}

__int32 _stdcall InitRain(__int32 TickCount)
{
	__int16 A;
	srand((unsigned __int32)TickCount);
	for(A=0;A<MAX_RAIN_DROPS;A++){
		RainDrops[A].lifetime = 12 + (rand()>>10);
		RainDrops[A].x = (rand()/86);
		RainDrops[A].y = (rand()/84)-(RainDrops[A].lifetime * RAIN_DROP_SPEED);
	}
	return 0;
	CurTick = 0;
}

void ReInitRainDrop(unsigned __int8 CurDrop) {
	RainDrops[CurDrop].lifetime = 12 + (rand()>>11);
	RainDrops[CurDrop].x = (rand()/86);
	RainDrops[CurDrop].y = (rand()/84)-(RainDrops[CurDrop].lifetime * RAIN_DROP_SPEED);
	
}

__int32 _stdcall LetItRain(__int32 sfcptr, __int32 TickCount)
{
	unsigned __int8 A, B, C, D, F, G;
	unsigned __int16 E;
	unsigned __int8 alpha=175;
	unsigned __int16 *curptr = (unsigned __int16 *)sfcptr;
	if (TickCount >= CurTick2) {
		E = rand();
		if (E < 1000) {
			Direction = 1;
		} else if (E > 31767) {
			Direction = 2;
		}
	CurTick2 = TickCount + 150;
	}
	for(A=0;A<MAX_RAIN_DROPS;A++) {
		if (TickCount >= CurTick) {
			if (Direction == 1) {
				RainDrops[A].x += RAIN_DROP_SPEED>>2;
			} else if (Direction ==2) {
				RainDrops[A].x -= RAIN_DROP_SPEED>>2;
			}
			B = 1;
			RainDrops[A].y += RAIN_DROP_SPEED;
			RainDrops[A].lifetime--;
			if (RainDrops[A].y > 384 || RainDrops[A].lifetime <= 0) {
				ReInitRainDrop(A);
			}
		}
		for(C=0;C<10;C++) {
			for(D=0;D<3;D++) {
				if (Direction ==1) {
					F = C;
					G = abs(D - 2);
				} else {
					F = C;
					G = D;
				}
				if (RainDrops[A].y + (__int16)C > 0 && RainDrops[A].y + (__int16)C < 384) {
					if (!(PixRain[F][G][0] == 0 && PixRain[F][G][1] == 0 && PixRain[F][G][2] == 0)) {
						curptr = (unsigned __int16 *)sfcptr + ((RainDrops[A].y + C) * 384 + RainDrops[A].x + D);
						*curptr = PixRain[F][G][0] << 11 | PixRain[F][G][1] << 5 | PixRain[F][G][2];
					}
				}
			}
		}
	}
	if (B == 1) {
		CurTick = TickCount + 50;
		B = 0;
	}
	return CurTick;
}


__int32 _stdcall InitSnow(__int32 TickCount)
{
	__int16 A;
	srand((unsigned __int32)TickCount);
	for(A=0;A<MAX_SNOW_FLAKES;A++){
		SnowFlakes[A].lifetime = 20 + (__int16)(((double)rand()/32767) * 50);
		SnowFlakes[A].x = (rand()/86);
		SnowFlakes[A].y = (rand()/84)-(SnowFlakes[A].lifetime * SNOW_FLAKE_SPEED);
		SnowFlakes[A].DESTROY = (__int16)(((double)rand()/32767) * 255);
	}
	return 0;
	CurTick = 0;
}

void ReInitSnowFlake(unsigned __int16 CurDrop) {
	SnowFlakes[CurDrop].lifetime = 20 + (rand()>>10);
	SnowFlakes[CurDrop].x = (rand()/86);
	SnowFlakes[CurDrop].y = (rand()/84)-(SnowFlakes[CurDrop].lifetime * SNOW_FLAKE_SPEED );
	SnowFlakes[CurDrop].DESTROY = 255;
}

__int32 _stdcall LetTheSnowFromHeavenFallToEarthBABY(__int32 sfcptr, __int32 TickCount)
{
	unsigned __int16 A, B, C, D;
	unsigned __int8 alpha=175;
	unsigned __int16 *curptr = (unsigned __int16 *)sfcptr;

	for(A=0;A<MAX_SNOW_FLAKES;A++) {
		if (TickCount >= CurTick) {
			B = 1;
			if (SnowFlakes[A].DESTROY == 255) {
				SnowFlakes[A].y += SNOW_FLAKE_SPEED;
				C = rand();
				if (TickCount >= CurTick2) { 
					if (C < 10000) {
						//SnowFlakes[A].x--;
						SnowFlakes[A].direction = 2;
						SnowFlakes[A].x--;
					} else if (C > 22767) {
						//SnowFlakes[A].x++;
						SnowFlakes[A].direction = 1;
						SnowFlakes[A].x++;
					}
				
				CurTick2 = TickCount + 100;
				}
				if (C > 10000) { if (C < 22767) {
					if (SnowFlakes[A].direction == 1) {
						SnowFlakes[A].x++;	
					} else if (SnowFlakes[A].direction ==2) {
						SnowFlakes[A].x--;
					}

				}}
				if (SnowFlakes[A].direction == 0) {
					CurTick2 = CurTick;
				}
			}
			SnowFlakes[A].lifetime--;
			if (SnowFlakes[A].y > 384) {
				ReInitSnowFlake(A);
			}
			if (SnowFlakes[A].lifetime == 0) {
				if (SnowFlakes[A].DESTROY >= 5) {
					SnowFlakes[A].DESTROY -=5;
					SnowFlakes[A].lifetime = 1;
				} else {
					ReInitSnowFlake(A);
				}
			}
		}
		for(C=0;C<5;C++) {
			for(D=0;D<5;D++) {
				if (SnowFlakes[A].y + (__int16)C > 0 && SnowFlakes[A].y + (__int16)C < 384) {
					if (SnowFlakes[A].x + (__int16)C > 0 && SnowFlakes[A].x + (__int16)C < 384) {
						if (!(PixSnow[C][D][0] == 0 && PixSnow[C][D][1] == 0 && PixSnow[C][D][2] == 0)) {
							curptr = (unsigned __int16 *)sfcptr + ((SnowFlakes[A].y + C) * 384 + SnowFlakes[A].x + D);
							//*curptr = PixSnow[C][D][0] << 11 | PixSnow[C][D][1] << 5 | PixSnow[C][D][2];
							*curptr = (63488 & ((*curptr & 63488) + ((((PixSnow[C][D][0]<<11) - (*curptr & 63488)) * SnowFlakes[A].DESTROY) >>8))) | (2016 & ((*curptr & 2016) + ((((PixSnow[C][D][1]<<5) - (*curptr & 2016)) * SnowFlakes[A].DESTROY) >>8))) | (31 & ((*curptr & 31) + (((PixSnow[C][D][2] - (*curptr & 31)) * SnowFlakes[A].DESTROY) >>8)));
						}
					}
				}
			}
		}
	}
	if (B == 1) {
		CurTick = TickCount + 50;
		B = 0;
	}
	return CurTick;
}

__int32 _stdcall EncryptDataFile(char *strptr)
{
	char FileName[256];
	char Buffer[32768];
	char *ptrBuffer = Buffer;
	FILE *CurFile;
	__int32 FileSize, ReadLength, cs;
	__int64 XORValue;
	strcpy(FileName,strptr);
	
	XORValue = (170) + (170 << 8) + (170 << 16) + (170 << 24) + (170 << 32) + (170 << 40) + (170 << 48) + (170 << 56);

	if((CurFile = fopen(FileName,"rb+")) == NULL) {
		return 1;
	} else {
		fseek(CurFile,0,SEEK_END);
		FileSize = ftell(CurFile);
		rewind(CurFile);
		while(FileSize)
		{
			if (FileSize < 32768) {
				ReadLength = FileSize;
				FileSize = 0;
			} else {
				ReadLength = 32768;
				FileSize -= 32768;
			}
			cs = ftell(CurFile);
			fread(Buffer,1,ReadLength,CurFile);
			__asm
			{
				mov     esi,4096			// 4096 iterations
				mov		edi,ptrBuffer
				movq	mm1,XORValue
				NextQuadWord:
				movq    mm0,[edi]		// move 8 bytes into the mm0 register
				pxor	mm0,mm1
				movq	[edi],mm0
				add		edi,8
				dec		esi
				jnz		NextQuadWord
				emms
			}
			fseek(CurFile,cs,SEEK_SET);
			fwrite(Buffer,1,ReadLength,CurFile);
		}
	}
	fclose(CurFile);
	return 0;
}

__int32 _stdcall EOP(char *strptr, __int8 key)
{
	char *St2;
	char *p;
	p = malloc(strlen(strptr)-1);
	/*if (!p) {
		return 0;
	} else {
		St2 = p;
		while (St2) {
			//*St2 = *St2 ^ key;
			St2++;
		}
	}*/
	
	
	return strlen(p);
}
